<%@ Import Namespace="DNNMasters.UMS.UI.UserControls" %>
<%@ Import Namespace="DotNetNuke.Services.Localization" %>
<%@ Control Language="c#" AutoEventWireup="false" CodeBehind="UMS_Roles.ascx.cs"
    Inherits="DNNMasters.UMS.UI.UserControls.UMS_Roles" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<%@ Register TagPrefix="componentart" Namespace="DNNMasters.UMS.ComponentArt.Web.UI.N2"
    Assembly="DNNMasters.UMS.ComponentArt.Web.UI.N2" %>
<%@ Register TagPrefix="dnn" TagName="Label" Src="~/controls/LabelControl.ascx" %>
<%@ Register TagPrefix="dnn" TagName="SectionHead" Src="~/controls/SectionHeadControl.ascx" %>
<%@ Register TagPrefix="dnn" TagName="Url" Src="~/controls/UrlControl.ascx" %>
<link href="<%= ModulePath.Replace("UI/UserControls/", "") %>/module.css" type="text/css"
    rel="stylesheet" />

<script type="text/javascript">
    //<![CDATA[

    function _treRoles_onNodeExpand(sender, eventArgs) {
        var node = eventArgs.get_node();
        DNNMasters.UMS.UI.UserControls.UMS_RolesService.SessionExpandedNode(node.ID, node.get_expanded());
    }

    function _treRoles_onNodeCollapse(sender, eventArgs) {
        var node = eventArgs.get_node();
        DNNMasters.UMS.UI.UserControls.UMS_RolesService.SessionExpandedNode(node.ID, node.get_expanded());
    }

    function _treRoles_onContextMenu(sender, eventArgs) {
        var nodeID = eventArgs.get_node().get_id();
        //var deleteNode = _treMenu.findItemById("Delete").set_visible(false);
        var clickOnRole = (nodeID.indexOf("role") != -1);
        var clickOnGroup = (nodeID.indexOf("group") != -1);
        var clickOnPortal = (nodeID.indexOf("portal") != -1);


        var addNode = _treMenu.findItemById("AddNew");
        var addRoleNode = _treMenu.findItemById("AddNewRole");
        var addGroupNode = _treMenu.findItemById("AddNewGroup");
        var duplocateNode = _treMenu.findItemById("Duplicate");
        var renameNode = _treMenu.findItemById("Rename");
        var deleteNode = _treMenu.findItemById("Delete");

        if (addNode != null)
            addNode.set_visible(clickOnGroup || clickOnPortal);

        if (addGroupNode != null)
            addGroupNode.set_visible(clickOnPortal);

        if (duplocateNode != null)
            duplocateNode.set_visible(clickOnRole || clickOnGroup);

        if (renameNode != null)
            renameNode.set_visible(clickOnRole || clickOnGroup);

        if (deleteNode != null)
            deleteNode.set_visible(clickOnRole || clickOnGroup);

        if (clickOnRole || clickOnGroup || clickOnPortal) {
            _treMenu.showContextMenuAtEvent(eventArgs.get_event(), eventArgs.get_node());
        }
    }

    function _treRoles_onNodeMove(sender, eventArgs) {
        var arrItems = new Array;
        if (_treRoles.get_selectedNode().get_isMultipleSelected()) {
            var nodes = _treRoles.get_multipleSelectedNodes();
            for (var i = 0; i < nodes.length; i++) {
                var node = nodes[i];
                arrItems[i] = node.get_id();
            }
        }
        else
            arrItems[0] = eventArgs.get_node().get_id();

        var targetNode = eventArgs.get_newParentNode();
        document.getElementById('<% =_treRoles.ClientID %>').style.cursor = 'wait';
        _treRoles.set_hoverNodeCssClass("WaitCursor");
        _treRoles.set_selectedNodeCssClass("WaitCursor");
        DNNMasters.UMS.UI.UserControls.UMS_RolesService.TreeNodeMoved(arrItems, targetNode.ID, SucceededCallback);
        eventArgs.set_cancel(true);
    }

    function _treMenu_onItemSelect(sender, eventArgs) {
        var menuItem = eventArgs.get_item();
        var contextDataNode = menuItem.get_parentMenu().get_contextData();
        var command = menuItem.get_id();

        if (command == "AddNewRole") {
            var parentNode = contextDataNode.get_parentNode();
            _treRoles.beginUpdate();
            var newNode = new DNNMasters.UMS.ComponentArt.Web.UI.N2.TreeViewNode();
            newNode.set_text('New Role');
            newNode.set_imageUrl("~/images/icon_hostusers_16px.gif");
            newNode.set_id(contextDataNode.get_id() + "_newrole");
            if (contextDataNode.get_id().indexOf("role_") == -1)
                contextDataNode.get_nodes().add(newNode);
            else
                parentNode.get_nodes().add(newNode);
            _treRoles.endUpdate();
            if (contextDataNode.get_id().indexOf("group") != -1)
                contextDataNode.expand(false);
            newNode.Edit();
        }
        else if (command == "AddNewGroup") {

            //var parentNode = contextDataNode.get_parentNode();
            var parentNode = contextDataNode;
            _treRoles.beginUpdate();
            var newNode = new DNNMasters.UMS.ComponentArt.Web.UI.N2.TreeViewNode();
            newNode.set_text('New Role Group');
            newNode.set_imageUrl("~/images/icon_users_16px.gif");
            newNode.set_id(contextDataNode.get_id() + "_newgroup");
            if (parentNode.get_id().indexOf("portal_") != -1)
                parentNode.get_nodes().add(newNode);
            else
                parentNode.get_parentNode().get_nodes().add(newNode);
            _treRoles.endUpdate();
            newNode.Edit();
        }
        else {
            if (command == "Delete")
                if (!confirm('Are you sure to delete this item?'))
                return
            var arrItems = new Array;
            if (_treRoles.get_selectedNode().get_isMultipleSelected()) {
                var nodes = _treRoles.get_multipleSelectedNodes();
                for (var i = 0; i < nodes.length; i++) {
                    var node = nodes[i];
                    arrItems[i] = node.get_id();
                }
            }
            else
                arrItems[0] = contextDataNode.get_id();

            DNNMasters.UMS.UI.UserControls.UMS_RolesService.MenuAction(arrItems, command, SucceededCallback);
        }
    }

    function _treRoles_onNodeRename(sender, eventArgs) {
        var nodeName = eventArgs.get_node().get_text();
        DNNMasters.UMS.UI.UserControls.UMS_RolesService.RenameNode(eventArgs.get_node().get_id(), nodeName, SucceededCallback);
    }

    function SucceededCallback(result, eventArgs) {
        document.getElementById('<% =_treRoles.ClientID %>').style.cursor = 'default';
        _treRoles.set_hoverNodeCssClass("HoverTreeNode");
        _treRoles.set_selectedNodeCssClass("SelectedTreeNode");
        if (result == null || result == true) {
            _treRoles.loadFromWebService('DNNMasters.UMS.UI.UserControls.UMS_RolesService', 'buildRolesTree');
            _treRoles.render();
        }
    }

    function SaveRole() {

    }

    function SaveRoleGroup() {
    }

    //]]>
</script>

<componentart:Menu id="_treMenu" Orientation="Vertical" DefaultGroupCssClass="MenuGroup"
    DefaultItemLookID="DefaultItemLook" DefaultGroupItemSpacing="1" ImagesBaseUrl="~/DesktopModules/DNNMasters.UMS/images/menu_images/"
    EnableViewState="false" ContextMenu="Custom" runat="server" AutoPostBackOnSelect="false">
    <clientevents>
      <ItemSelect EventHandler="_treMenu_onItemSelect" />
    </clientevents>
    <itemlooks>
      <ComponentArt:ItemLook LookID="DefaultItemLook" CssClass="MenuItem" HoverCssClass="MenuItemHover" ExpandedCssClass="MenuItemHover" LeftIconWidth="20" LeftIconHeight="18" LabelPaddingLeft="10" LabelPaddingRight="10" LabelPaddingTop="3" LabelPaddingBottom="4" />
      <ComponentArt:ItemLook LookID="BreakItem" CssClass="MenuBreak" />
    </itemlooks>
</componentart:Menu>
<table id="tblTree">
    <tr>
        <td valign="top">
            <componentart:TreeView id="_treRoles" Height="400" Width="300" KeyboardEnabled="false"
                CssClass="TreeView" NodeCssClass="TreeNode" SelectedNodeCssClass="SelectedTreeNode"
                HoverNodeCssClass="HoverTreeNode" LineImageWidth="19" LineImageHeight="20" DefaultImageWidth="16"
                DefaultImageHeight="16" NodeLabelPadding="3" ImagesBaseUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/"
                ShowLines="true" LineImagesFolderUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/lines"
                EnableViewState="true" runat="server" MultipleSelectEnabled="true" MultipleSelectedNodeCssClass="SelectedTreeNode"
                AutoPostBackOnNodeMove="false" AutoPostBackOnNodeRename="false" WebService="DNNMasters.UMS.UI.UserControls.UMS_RolesService"
                WebServiceMethod="buildRolesTree">
                <clientevents>
              <ContextMenu EventHandler="_treRoles_onContextMenu" />
              <NodeMove EventHandler="_treRoles_onNodeMove" />
              <NodeExpand EventHandler="_treRoles_onNodeExpand" />
              <NodeCollapse EventHandler="_treRoles_onNodeCollapse" />
              <NodeRename EventHandler="_treRoles_onNodeRename" />
          </clientevents>
            </componentart:TreeView>
        </td>
        <td id="_tdEdit" runat="server" valign="top" visible="false">
            <asp:HiddenField ID="_hfItemPortalID" runat="server" />
            <asp:HiddenField ID="_hfItemID" runat="server" />
            <asp:Panel ID="_pnlGroupEdit" runat="server" Visible="false">
                <%--<div id="divRoleGroup" style="display: none;">--%>
                <dnn:label id="lblGroupName" runat="server" Suffix=":" CssClass="Normal" controlname="_txbGroupName" />
                <asp:TextBox ID="_txbGroupName" runat="server" CssClass="Normal" Width="250" /><br />
                <dnn:label id="lblGroupDesc" runat="server" Suffix=":" CssClass="Normal" controlname="_txbGroupDesc" />
                <asp:TextBox ID="_txbGroupDesc" runat="server" CssClass="Normal" Width="250" TextMode="MultiLine"
                    Rows="5" /><br />
                <%--<input type="button" id="_btnSaveRoleGroup" value="Save" class="Normal" onclick="SaveRoleGroup();" />--%>
                <%--</div>--%>
            </asp:Panel>
            <%--<div id="divRole" style="display:none;" >--%>
            <asp:Panel ID="_pnlRoleEdit" runat="server" Visible="false">
                <dnn:label id="lblRoleName" runat="server" Suffix=":" CssClass="Normal" controlname="_txbRoleName" />
                <asp:TextBox ID="_txbRoleName" runat="server" CssClass="Normal" Width="250" />
                <asp:RequiredFieldValidator ID="_valRoleName" ControlToValidate="_txbRoleName" runat="server"
                    ErrorMessage="*" Display="Dynamic" ValidationGroup="grpRoleName" />
                <br />
                <dnn:label id="lblRoleDesc" runat="server" Suffix=":" CssClass="Normal" controlname="_txbRoleDesc" />
                <asp:TextBox ID="_txbRoleDesc" runat="server" CssClass="Normal" Width="250" TextMode="MultiLine"
                    Rows="5" /><br />
                <asp:CheckBox ID="_chkPublicRole" CssClass="Normal" resourcekey="_chkPublicRole"
                    runat="server" /><br />
                <asp:CheckBox ID="_chkAutoAssign" CssClass="Normal" resourcekey="_chkAutoAssign"
                    runat="server" />
                <br />
                <dnn:label id="lblSecurityMode" runat="server" Suffix=":" CssClass="Normal" controlname="_txbRoleName" />
                <asp:DropDownList ID="_ddlSecurityMode" runat="server">
                </asp:DropDownList>
                <dnn:SectionHead ID="dshAdvanced" CssClass="Head" runat="server" Text="Advanced Settings"
                    Section="tblAdvanced" ResourceKey="AdvancedSettings" IncludeRule="True" IsExpanded="False">
                </dnn:SectionHead>
                <table id="tblAdvanced" cellspacing="0" cellpadding="2" summary="Advanced Settings Design Table"
                    border="0" runat="server">
                    <tr>
                        <td colspan="2">
                            <asp:Label ID="_lblProcessorWarning" Visible="false" CssClass="Normal" runat="server"
                                resourcekey="ProcessorWarning" EnableViewState="False" />
                        </td>
                    </tr>
                    <tr id="_trServiceFee" runat="server" valign="top">
                        <td class="SubHead">
                            <dnn:Label ID="plServiceFee" runat="server" ResourceKey="ServiceFee" Suffix=":" ControlName="_txtServiceFee" />
                        </td>
                        <td>
                            <asp:TextBox ID="_txtServiceFee" CssClass="NormalTextBox" runat="server" MaxLength="50"
                                Columns="30" Width="100" />
                            <asp:CompareValidator ID="valServiceFee1" CssClass="NormalRed" runat="server" resourcekey="valServiceFee1"
                                ControlToValidate="_txtServiceFee" ErrorMessage="<br>Service Fee Value Entered Is Not Valid"
                                Display="Dynamic" Type="Currency" Operator="DataTypeCheck" />
                            <asp:CompareValidator ID="valServiceFee2" CssClass="NormalRed" runat="server" resourcekey="valServiceFee2"
                                ControlToValidate="_txtServiceFee" ErrorMessage="<br>Service Fee Must Be Greater Than or Equal to Zero"
                                Display="Dynamic" Operator="GreaterThanEqual" ValueToCompare="0" />
                        </td>
                    </tr>
                    <tr id="_trBillingPeriod" valign="top" runat="server">
                        <td class="SubHead">
                            <dnn:Label ID="plBillingPeriod" runat="server" ResourceKey="BillingPeriod" Suffix=":"
                                ControlName="_txtBillingPeriod" />
                        </td>
                        <td>
                            <asp:TextBox ID="_txtBillingPeriod" CssClass="NormalTextBox" runat="server" MaxLength="50"
                                Columns="30" Width="100" />&nbsp;&nbsp;
                            <asp:DropDownList ID="_cboBillingFrequency" CssClass="NormalTextBox" runat="server"
                                Width="100px" DataValueField="value" DataTextField="text" />
                            <asp:CompareValidator ID="valBillingPeriod1" CssClass="NormalRed" runat="server"
                                resourcekey="valBillingPeriod1" ControlToValidate="_txtBillingPeriod" ErrorMessage="<br>Billing Period Value Entered Is Not Valid"
                                Display="Dynamic" Type="Integer" Operator="DataTypeCheck" />
                            <asp:CompareValidator ID="valBillingPeriod2" CssClass="NormalRed" runat="server"
                                resourcekey="valBillingPeriod2" ControlToValidate="_txtBillingPeriod" ErrorMessage="<br>Billing Period Must Be Greater Than or Equal to Zero"
                                Display="Dynamic" Operator="GreaterThan" ValueToCompare="0" />
                        </td>
                    </tr>
                    <tr id="_trTrialFee" valign="top" runat="server">
                        <td class="SubHead">
                            <dnn:Label ID="plTrialFee" runat="server" ResourceKey="TrialFee" Suffix=":" ControlName="_txtTrialFee">
                            </dnn:Label>
                        </td>
                        <td>
                            <asp:TextBox ID="_txtTrialFee" CssClass="NormalTextBox" runat="server" MaxLength="50"
                                Columns="30" Width="100" />
                            <asp:CompareValidator ID="valTrialFee1" CssClass="NormalRed" runat="server" resourcekey="valTrialFee1"
                                ControlToValidate="_txtTrialFee" ErrorMessage="<br>Trial Fee Value Entered Is Not Valid"
                                Display="Dynamic" Type="Currency" Operator="DataTypeCheck" />
                            <asp:CompareValidator ID="valTrialFee2" CssClass="NormalRed" runat="server" resourcekey="valTrialFee2"
                                ControlToValidate="_txtTrialFee" ErrorMessage="<br>Trial Fee Must Be Greater Than Zero"
                                Display="Dynamic" Operator="GreaterThanEqual" ValueToCompare="0" />
                        </td>
                    </tr>
                    <tr id="_trTrialPeriod" valign="top" runat="server">
                        <td class="SubHead">
                            <dnn:Label ID="plTrialPeriod" runat="server" ResourceKey="TrialPeriod" Suffix=":"
                                ControlName="_txtTrialPeriod" />
                        </td>
                        <td>
                            <asp:TextBox ID="_txtTrialPeriod" CssClass="NormalTextBox" runat="server" MaxLength="50"
                                Columns="30" Width="100" />&nbsp;&nbsp;
                            <asp:DropDownList ID="_cboTrialFrequency" CssClass="NormalTextBox" runat="server"
                                Width="100px" DataValueField="value" DataTextField="text" />
                            <asp:CompareValidator ID="valTrialPeriod1" CssClass="NormalRed" runat="server" resourcekey="valTrialPeriod1"
                                ControlToValidate="_txtTrialPeriod" ErrorMessage="<br>Trial Period Value Entered Is Not Valid"
                                Display="Dynamic" Type="Integer" Operator="DataTypeCheck" />
                            <asp:CompareValidator ID="valTrialPeriod2" CssClass="NormalRed" runat="server" resourcekey="valTrialPeriod2"
                                ControlToValidate="_txtTrialPeriod" ErrorMessage="<br>Trial Period Must Be Greater Than Zero"
                                Display="Dynamic" Operator="GreaterThan" ValueToCompare="0" />
                        </td>
                    </tr>
                    <tr valign="top">
                        <td class="SubHead">
                            <dnn:Label ID="plRSVPCode" runat="server" ControlName="_txtRSVPCode" />
                        </td>
                        <td>
                            <asp:TextBox ID="_txtRSVPCode" CssClass="NormalTextBox" runat="server" MaxLength="50"
                                Columns="30" Width="100" />
                        </td>
                    </tr>
                    <tr valign="top">
                        <td class="SubHead">
                            <dnn:Label ID="plRSVPLink" runat="server" ControlName="_txtRSVPLink" />
                        </td>
                        <td>
                            <asp:TextBox ID="_txtRSVPLink" CssClass="NormalTextBox" runat="server" Width="325"
                                ReadOnly="True" />
                        </td>
                    </tr>
                    <tr>
                        <td class="SubHead" valign="top">
                            <dnn:Label ID="plIcon" Text="Icon:" runat="server" ControlName="_ctlIcon" />
                        </td>
                        <td>
                            <dnn:Url ID="_ctlIcon" runat="server" Width="325" ShowUrls="False" ShowTabs="False"
                                ShowLog="False" ShowTrack="False" Required="False" />
                        </td>
                    </tr>
                </table>
                <%--<input type="button" id="_btnSaveRole" value="Save Role" class="Normal" onclick="SaveRole();" />--%>
            </asp:Panel>
            <ul class="dnnActions dnnClear" >
            <li><asp:LinkButton ID="_lnkSave" resourcekey="_lnkSave" runat="server" CssClass="dnnPrimaryAction" ValidationGroup="grpRoleName" /></li>
            <li><asp:LinkButton ID="_lnkCancelEdit" resourcekey="_lnkCancelEdit" runat="server" CssClass="dnnSecondaryAction" /></li>
            
            
            </ul>
            <%--</div>--%>
        </td>
    </tr>
</table>
