<%@ Control Language="c#" AutoEventWireup="false" CodeBehind="UMS_Security.ascx.cs"
    Inherits="DNNMasters.UMS.UI.UserControls.UMS_Security" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<%@ Register TagPrefix="componentart" Namespace="DNNMasters.UMS.ComponentArt.Web.UI.N2"
    Assembly="DNNMasters.UMS.ComponentArt.Web.UI.N2" %>
<%@ Register TagPrefix="dnn" TagName="Label" Src="~/controls/LabelControl.ascx" %>
<%@ Import Namespace="DotNetNuke.Services.Localization" %>

<link href="<%= ModulePath.Replace("UI/UserControls/", "") %>/module.css" type="text/css"
    rel="stylesheet" />

<script type="text/javascript">
    //<![CDATA[
    
    function _treActions_onNodeSelect(sender, eventArgs)
    {
        DNNMasters.UMS.UI.UserControls.UMS_SecurityService.GetPermission(eventArgs.get_node().get_id(), CheckRoles);
        LoadDenyData();
    }
    
    function _treSecurityRoles_onNodeExpand(sender, eventArgs)
    {
        if(_treActions.get_selectedNode() != null)
            DNNMasters.UMS.UI.UserControls.UMS_SecurityService.GetPermission(_treActions.get_selectedNode().get_id(), CheckRoles);
    }
    
    function CheckRoles(result, eventArgs)
    {
        if(result != null)
        {
            _treSecurityRoles.unCheckAll();
            var iDs = result.split('|');
            for(var i = 0; i< iDs.length; i++)
            {
                if(iDs[i] != '')
                {
                    var nodeToCheck = _treSecurityRoles.findNodeById('role_' + iDs[i]);
                    if(nodeToCheck != null)
                        nodeToCheck.set_checked(true);
                        
                    if(iDs[i].indexOf('g') != -1)
                    {
                        var nodeToCheck = _treSecurityRoles.findNodeById('group_' + iDs[i].replace('g', ''));
                        if(nodeToCheck != null)
                        {
                            nodeToCheck.set_checked(true);
                            var groupNodes = nodeToCheck.get_nodes();
                            for (var ci = 0; ci < groupNodes.get_length(); ci++)
                            {
                                if(groupNodes.getNode(ci) != null)
                                {
                                    //groupNodes.getNode(ci).set_showCheckBox(false);
                                    groupNodes.getNode(ci).set_checked(true);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    
    function _treSecurityRoles_onNodeCheckChange(sender, eventArgs)
    {
        document.getElementById('<% =_lblPermSaved.ClientID %>').style.display = "none";
        if(_treActions.get_selectedNode() == null)
        {
            alert('First you must choose Action from Tree!');
            return;
        }
           
        var actions = new Array;
        if(_treActions.get_selectedNode().get_isMultipleSelected())
        {
            var nodes = _treActions.get_multipleSelectedNodes();
            for(var i = 0; i < nodes.length; i++)
            {
                var node = nodes[i];
                actions[i] = node.get_id();
            }
        }
        else
            actions[0] = _treActions.get_selectedNode().get_id();
        
        
        // if group is selected then select child roles
        if(eventArgs.get_node().get_id().indexOf('g') != -1)
        {
            var groupNodes = eventArgs.get_node().get_nodes();
            for (var i = 0; i < groupNodes.get_length(); i++)
            {
                //groupNodes.getNode(i).set_showCheckBox(!eventArgs.get_node().get_checked());
                groupNodes.getNode(i).set_checked(eventArgs.get_node().get_checked());
            }
        }

        DNNMasters.UMS.UI.UserControls.UMS_SecurityService.SetPermission(actions, eventArgs.get_node().get_id(), eventArgs.get_node().get_checked());
    }
    
    function SavePerm()
    {
        document.getElementById('<% =_lblPermSaving.ClientID %>').style.display = "inline";
        DNNMasters.UMS.UI.UserControls.UMS_SecurityService.SavePerm(SaveResult);
    }
    
    function SaveResult(result, eventArgs)
    {
        document.getElementById('<% =_lblPermSaving.ClientID %>').style.display = "none";
        document.getElementById('<% =_lblPermSaved.ClientID %>').style.display = "inline";
    }
    
    function _treDenyRoles_onNodeCheckChange(sender, eventArgs)
    {
        if(_treActions.get_selectedNode() == null)
        {
            alert('First you must choose Action from Tree!');
            return;
        }
        
        if(_treSecurityRoles.get_selectedNode() == null)
        {
            alert('First you must select Role in Tree!');
            return;
        }
        
        var elementID = _treSecurityRoles.get_selectedNode().get_id();
        var checkedNodeID = eventArgs.get_node().get_id();
        var checkStatus =  eventArgs.get_node().get_checked();
        
        var actions = new Array;
        if(_treActions.get_selectedNode().get_isMultipleSelected())
        {
            var nodes = _treActions.get_multipleSelectedNodes();
            for(var i = 0; i < nodes.length; i++)
            {
                var node = nodes[i];
                actions[i] = node.get_id();
            }
        }
        else
            actions[0] = _treActions.get_selectedNode().get_id();
        
        if(checkedNodeID.indexOf('group') != -1)
        {
            var groupNodes = eventArgs.get_node().get_nodes();
            for (var i = 0; i < groupNodes.get_length(); i++)
            {
                groupNodes.getNode(i).set_checked(eventArgs.get_node().get_checked());
            }
        }

        DNNMasters.UMS.UI.UserControls.UMS_SecurityService.SetDeny(actions, elementID, checkedNodeID, checkStatus);
    }
    
    function LoadDenyData()
    {
        if(_treSecurityRoles.get_selectedNode() == null) return;
        
        var actions = new Array;
        if(_treActions.get_selectedNode().get_isMultipleSelected())
        {
            var nodes = _treActions.get_multipleSelectedNodes();
            for(var i = 0; i < nodes.length; i++)
            {
                var node = nodes[i];
                actions[i] = node.get_id();
            }
        }
        else
            actions[0] = _treActions.get_selectedNode().get_id();
        DNNMasters.UMS.UI.UserControls.UMS_SecurityService.GetDeny(actions, _treSecurityRoles.get_selectedNode().get_id(), CheckDeny);
    }
    
    function _treDenyRoles_onNodeExpand(sender, eventArgs)
    {
        LoadDenyData();
    }
    
    function _treSecurityRoles_onNodeSelect(sender, eventArgs)
    {
        LoadDenyData();
    }
    
    function CheckDeny(result, eventArgs)
    {
        if(result != null)
        {
            _treDenyRoles.unCheckAll();
            var iDs = result.split('|');
            for(var i = 0; i< iDs.length; i++)
            {
                if(iDs[i] != '')
                {
                    var nodeToCheck = _treDenyRoles.findNodeById(iDs[i]);
                    if(nodeToCheck != null)
                    {
                        nodeToCheck.set_checked(true);
                        
                        if(iDs[i].indexOf('group') != -1)
                        {
                            var groupNodes = nodeToCheck.get_nodes();
                            for (var ci = 0; ci < groupNodes.get_length(); ci++)
                            {
                                if(groupNodes.getNode(ci) != null)
                                {
                                    //groupNodes.getNode(ci).set_showCheckBox(false);
                                    groupNodes.getNode(ci).set_checked(true);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    
    
    //]]>
</script>

<table cellpadding="10">
    <tr>
        <td valign="top">
            <dnn:label id="lblActrionsTree" runat="server" CssClass="SubHead" Suffix=":" />
            <componentart:TreeView id="_treActions" Height="340" Width="250" KeyboardEnabled="false"
                CssClass="TreeView" NodeCssClass="TreeNode" SelectedNodeCssClass="SelectedTreeNode"
                HoverNodeCssClass="HoverTreeNode" LineImageWidth="19" LineImageHeight="20" DefaultImageWidth="16"
                DefaultImageHeight="16" NodeLabelPadding="3" ImagesBaseUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/"
                ShowLines="true" LineImagesFolderUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/lines"
                EnableViewState="true" runat="server" MultipleSelectEnabled="true" MultipleSelectedNodeCssClass="SelectedTreeNode"
                DragAndDropEnabled="false" NodeEditingEnabled="false" Visible="true">
                <clientevents>
                    <NodeSelect EventHandler="_treActions_onNodeSelect" />
                </clientevents>
            </componentart:TreeView>
        </td>
        <td>
            <dnn:label id="lblRolesTree" runat="server" CssClass="SubHead" Suffix=":" />
            <componentart:TreeView id="_treSecurityRoles" Height="340" Width="250" KeyboardEnabled="false"
                CssClass="TreeView" NodeCssClass="TreeNode" SelectedNodeCssClass="SelectedTreeNode"
                HoverNodeCssClass="HoverTreeNode" LineImageWidth="19" LineImageHeight="20" DefaultImageWidth="16"
                DefaultImageHeight="16" NodeLabelPadding="3" ImagesBaseUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/"
                ShowLines="true" LineImagesFolderUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/lines"
                EnableViewState="true" runat="server" MultipleSelectEnabled="false" MultipleSelectedNodeCssClass="SelectedTreeNode"
                DragAndDropEnabled="false" NodeEditingEnabled="false" WebService="DNNMasters.UMS.UI.UserControls.UMS_RolesService"
                WebServiceMethod="buildRolesTree" WebServiceCustomParameter="chkRoles" >
                <clientevents>
                    <NodeCheckChange EventHandler="_treSecurityRoles_onNodeCheckChange" />
                    <NodeExpand EventHandler="_treSecurityRoles_onNodeExpand" />
                    <NodeSelect EventHandler="_treSecurityRoles_onNodeSelect" />
                </clientevents>
            </componentart:TreeView>
        </td>
        <td>
            <dnn:label id="lblDenyTree" runat="server" CssClass="SubHead" Suffix=":" />
            <componentart:TreeView id="_treDenyRoles" Height="340" Width="250" KeyboardEnabled="false"
                CssClass="TreeView" NodeCssClass="TreeNode" SelectedNodeCssClass="SelectedTreeNode"
                HoverNodeCssClass="HoverTreeNode" LineImageWidth="19" LineImageHeight="20" DefaultImageWidth="16"
                DefaultImageHeight="16" NodeLabelPadding="3" ImagesBaseUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/"
                ShowLines="true" LineImagesFolderUrl="~/DesktopModules/DNNMasters.UMS/images/treeview_images/lines"
                EnableViewState="true" runat="server" MultipleSelectEnabled="false" MultipleSelectedNodeCssClass="SelectedTreeNode"
                DragAndDropEnabled="false" NodeEditingEnabled="false" WebService="DNNMasters.UMS.UI.UserControls.UMS_RolesService"
                WebServiceMethod="buildRolesTree" WebServiceCustomParameter="chkRoles" >
                <clientevents>
                    <NodeCheckChange EventHandler="_treDenyRoles_onNodeCheckChange" />
                    <NodeExpand EventHandler="_treDenyRoles_onNodeExpand" />
                </clientevents>
            </componentart:TreeView>
        </td>
    </tr>
    <tr>
        <td colspan="3" align="center">
            <input type="button" id="_btnSavePerm" value="Save" class="Normal" onclick="SavePerm();" /><br />
            <asp:Label ID="_lblPermSaving" resourcekey="_lblPermSaving" runat="server" CssClass="Normal" style="display:none;" />
            <asp:Label ID="_lblPermSaved" resourcekey="_lblPermSaved" runat="server" CssClass="Normal" style="display:none;" />
        </td>
    </tr>
</table>
